<?php
/**
 * Plugin Name: tigaman webdesign - codeblock with copy button shortcode
 * Plugin URI: https://www.tigaman.com/
 * Description: Add [codeblock] [/codeblock] shortcode to classic editor / Update:
protection against overflowing text
response copy button
 * Version: 1.1
 * Author: tigaman webdesign
 * Author URI: https://www.tigaman.com
 * Author URI: https://www.tigaman.hu
 */
?>
<?php add_action('admin_print_footer_scripts','twd_quicktags');function twd_quicktags() {?>
<script type="text/javascript" charset="utf-8">QTags.addButton( 'eg_codeblock', 'codeblock','[codeblock]', '[/codeblock]' );</script>
<?php }?>
<?php 
add_shortcode( 'codeblock', 'codeblock_shortcode' );
function codeblock_shortcode( $atts, $content = null ) {
$id = get_the_ID();	
 $a = shortcode_atts( array(
 'id' => $id
 ), $atts );
 $output = '<div class="codearea" id="codearea' . esc_attr( $a['id'] ) . '">' . do_shortcode( $content ) . '</div>
<div id="codeareacopybutton" onclick="copyDivToClipboard()">Copy to Clipboard</div><div style="clear:both"></div> 
 <script type="text/javascript">function copyDivToClipboard(){var b=document.createRange();b.selectNode(document.getElementById("codearea' . esc_attr( $a['id'] ) . '")),window.getSelection().removeAllRanges(),window.getSelection().addRange(b),document.execCommand("copy"),window.getSelection().removeAllRanges(),document.getElementById("codeareacopybutton").innerHTML="Copied to Clipboard";var a=document.getElementById("codeareacopybutton");"red"===a.style.backgroundColor?a.style.backgroundColor="black":a.style.backgroundColor="darkolivegreen"}
</script>';
 return $output;
}
?>
<?php
// CSS file
add_action('wp_enqueue_scripts', 'twd_code_with_copy_button_plugin_styles');
  function twd_code_with_copy_button_plugin_styles() {
    wp_register_style('twd_code_with_copy_button', plugins_url('/twd-code-with-copy-button.css',__FILE__));
    wp_enqueue_style('twd_code_with_copy_button');
  }
?>